from pathlib import Path
from typing import List, Optional
from dataclasses import dataclass
from typing import Callable


@dataclass
class DiagFile:
    name: str
    lines: List[str]

    @classmethod
    def open(cls, path: Path) -> Optional["DiagFile"]:
        name = path.name
        try:
            with open(path, "r", encoding="utf-8", errors='replace') as file:
                lines = file.readlines()
            log_file = cls(name, lines)
            return log_file
        except Exception as e:
            print(f"Failed to open file {str(path)}: {e}")
            return None

    def map_lines(self, func: Callable[[str], str]):
        self.lines = list(map(func, self.lines))

    def prepend_line(self, line: str):
        self.lines.insert(0, line + "\n")
